xref: /xnu-11417.140.69/tools/remote_build.sh (revision 43a90889846e00bfb5cf1d255cdc0a701a1e05a4)
1*43a90889SApple OSS Distributions#!/bin/bash
2*43a90889SApple OSS Distributions#
3*43a90889SApple OSS Distributions# Script that rsyncs a source/build tree to a remote server, performs a build,
4*43a90889SApple OSS Distributions# and copies the result back
5*43a90889SApple OSS Distributions#
6*43a90889SApple OSS Distributions
7*43a90889SApple OSS Distributions# This script is invoked instead of the initial recursive make(1) in ./Makefile.
8*43a90889SApple OSS Distributions# First it must cache all binaries that might be used during the build by
9*43a90889SApple OSS Distributions# calling "make print_exports" (any target would work) with an overriden xcrun(1)
10*43a90889SApple OSS Distributions# which caches tools an SDKs into ./BUILD/obj/BuildTools. When the combined
11*43a90889SApple OSS Distributions# source+build tree is rsync-ed to the remote server, we run a script to
12*43a90889SApple OSS Distributions# re-initiate the build using an overriden xcrun(1) which hands back
13*43a90889SApple OSS Distributions# cached tools in ./BUILD/obj/BuildTools instead of whatever Xcode tools are on
14*43a90889SApple OSS Distributions# the remote system (or if no Xcode tools are installed remotely). Finally,
15*43a90889SApple OSS Distributions# the build results are copied back locally.
16*43a90889SApple OSS Distributions#
17*43a90889SApple OSS Distributions
18*43a90889SApple OSS Distributionsfunction die() {
19*43a90889SApple OSS Distributions    echo "$1" 1>&2
20*43a90889SApple OSS Distributions    exit 1
21*43a90889SApple OSS Distributions}
22*43a90889SApple OSS Distributions
23*43a90889SApple OSS Distributions
24*43a90889SApple OSS DistributionsTARGET=
25*43a90889SApple OSS Distributionsdeclare -a ARGS
26*43a90889SApple OSS Distributionsdeclare -a REMOTEARGS
27*43a90889SApple OSS Distributionsindex=0
28*43a90889SApple OSS Distributionsfor arg in "$@"; do
29*43a90889SApple OSS Distributions    case $arg in
30*43a90889SApple OSS Distributions	_REMOTEBUILD_TARGET=*)
31*43a90889SApple OSS Distributions	    TARGET=`echo $arg | awk -F= '{print $2}'`
32*43a90889SApple OSS Distributions	    continue
33*43a90889SApple OSS Distributions	    ;;
34*43a90889SApple OSS Distributions	_REMOTEBUILD_MAKE=*)
35*43a90889SApple OSS Distributions	    MAKE=`echo $arg | awk -F= '{print $2}'`
36*43a90889SApple OSS Distributions	    continue
37*43a90889SApple OSS Distributions	    ;;
38*43a90889SApple OSS Distributions	REMOTEBUILD=*)
39*43a90889SApple OSS Distributions	    # Don't restart another remote build remotely
40*43a90889SApple OSS Distributions	    ;;
41*43a90889SApple OSS Distributions	SRCROOT=*)
42*43a90889SApple OSS Distributions	    continue
43*43a90889SApple OSS Distributions	    ;;
44*43a90889SApple OSS Distributions	OBJROOT=*)
45*43a90889SApple OSS Distributions	    continue
46*43a90889SApple OSS Distributions	    ;;
47*43a90889SApple OSS Distributions	SYMROOT=*)
48*43a90889SApple OSS Distributions	    continue
49*43a90889SApple OSS Distributions	    ;;
50*43a90889SApple OSS Distributions	DSTROOT=*)
51*43a90889SApple OSS Distributions	    continue
52*43a90889SApple OSS Distributions	    ;;
53*43a90889SApple OSS Distributions	CCHROOT=*)
54*43a90889SApple OSS Distributions	    continue
55*43a90889SApple OSS Distributions	    ;;
56*43a90889SApple OSS Distributions	RC_XBS=*)
57*43a90889SApple OSS Distributions	    # Remote build isn't chrooted or special in any way
58*43a90889SApple OSS Distributions	    arg="VERBOSE=YES"
59*43a90889SApple OSS Distributions	    continue
60*43a90889SApple OSS Distributions	    ;;
61*43a90889SApple OSS Distributions	VERBOSE=YES)
62*43a90889SApple OSS Distributions	    set -x
63*43a90889SApple OSS Distributions	    ;;
64*43a90889SApple OSS Distributions    esac
65*43a90889SApple OSS Distributions    ARGS[$index]="$arg"
66*43a90889SApple OSS Distributions    REMOTEARGS[$index]="\"$arg\""
67*43a90889SApple OSS Distributions    index=$(($index+1))
68*43a90889SApple OSS Distributionsdone
69*43a90889SApple OSS Distributions
70*43a90889SApple OSS Distributions
71*43a90889SApple OSS DistributionsRSYNC_ARGS="-azvh"
72*43a90889SApple OSS DistributionsARGS[$index]="REMOTEBUILD="
73*43a90889SApple OSS DistributionsREMOTEARGS[$index]="\"REMOTEBUILD=\""
74*43a90889SApple OSS Distributions
75*43a90889SApple OSS Distributions# For some targets like installsrc, we can't to a remote build
76*43a90889SApple OSS DistributionsSKIPREMOTE=0
77*43a90889SApple OSS Distributionscase $TARGET in
78*43a90889SApple OSS Distributions    clean)
79*43a90889SApple OSS Distributions	SKIPREMOTE=1
80*43a90889SApple OSS Distributions	;;
81*43a90889SApple OSS Distributions    installsrc)
82*43a90889SApple OSS Distributions	SKIPREMOTE=1
83*43a90889SApple OSS Distributions	;;
84*43a90889SApple OSS Distributions    installopensource)
85*43a90889SApple OSS Distributions	SKIPREMOTE=1
86*43a90889SApple OSS Distributions	;;
87*43a90889SApple OSS Distributions    cscope)
88*43a90889SApple OSS Distributions	SKIPREMOTE=1
89*43a90889SApple OSS Distributions	;;
90*43a90889SApple OSS Distributions    tags)
91*43a90889SApple OSS Distributions	SKIPREMOTE=1
92*43a90889SApple OSS Distributions	;;
93*43a90889SApple OSS Distributions    help)
94*43a90889SApple OSS Distributions	SKIPREMOTE=1
95*43a90889SApple OSS Distributions	;;
96*43a90889SApple OSS Distributionsesac
97*43a90889SApple OSS Distributions
98*43a90889SApple OSS Distributionsif [ $SKIPREMOTE -eq 1 ]; then
99*43a90889SApple OSS Distributions    exec "$MAKE" "$TARGET" "${ARGS[@]}"
100*43a90889SApple OSS Distributionsfi
101*43a90889SApple OSS Distributions
102*43a90889SApple OSS DistributionsSRC="$(pwd -P)"
103*43a90889SApple OSS DistributionsSRCNAME="$(basename $SRC)"
104*43a90889SApple OSS Distributions
105*43a90889SApple OSS Distributions# Pick up build locations passed in the environment
106*43a90889SApple OSS DistributionsOBJROOT="${OBJROOT}"
107*43a90889SApple OSS DistributionsSYMROOT="${SYMROOT}"
108*43a90889SApple OSS DistributionsDSTROOT="${DSTROOT}"
109*43a90889SApple OSS Distributions
110*43a90889SApple OSS Distributionsif [ -z "${OBJROOT}" ]; then
111*43a90889SApple OSS Distributions    die "OBJROOT not set in environment"
112*43a90889SApple OSS Distributionsfi
113*43a90889SApple OSS Distributionsmkdir -p "${OBJROOT}" || die "Could not create ${OBJROOT}"
114*43a90889SApple OSS Distributions
115*43a90889SApple OSS Distributionsif [ -z "${SYMROOT}" ]; then
116*43a90889SApple OSS Distributions    die "SYMROOT not set in environment"
117*43a90889SApple OSS Distributionsfi
118*43a90889SApple OSS Distributionsmkdir -p "${SYMROOT}" || die "Could not create ${SYMROOT}"
119*43a90889SApple OSS Distributions
120*43a90889SApple OSS Distributionsif [ -z "${DSTROOT}" ]; then
121*43a90889SApple OSS Distributions    die "DSTROOT not set in environment"
122*43a90889SApple OSS Distributionsfi
123*43a90889SApple OSS Distributionsmkdir -p "${DSTROOT}" || die "Could not create ${DSTROOT}"
124*43a90889SApple OSS Distributions
125*43a90889SApple OSS Distributionsif [ "$REMOTEBUILD" = "$SPECIALREMOTEBUILD" ]; then
126*43a90889SApple OSS Distributions    :
127*43a90889SApple OSS Distributionselse
128*43a90889SApple OSS Distributions    DOINSTALLSRC=0
129*43a90889SApple OSS Distributions    REMOTE_SRCREL="./"
130*43a90889SApple OSS Distributions    BUILDTOOLSDIR="$OBJROOT"
131*43a90889SApple OSS Distributions    REMOTE_BUILDTOOLSREL="./BUILD/obj"
132*43a90889SApple OSS Distributions    BUILDSCRIPTDIR="$OBJROOT"
133*43a90889SApple OSS Distributions    REMOTE_BUILDSCRIPTREL="./BUILD/obj"
134*43a90889SApple OSS Distributions    BUILDSCRIPTNAME="build.sh"
135*43a90889SApple OSS Distributions    if [ ! -d "${OBJROOT}/SETUP" ]; then
136*43a90889SApple OSS Distributions    RSYNC_DELETE_EXCLUDED="--delete-excluded"
137*43a90889SApple OSS Distributions    else
138*43a90889SApple OSS Distributions    RSYNC_DELETE_EXCLUDED=""
139*43a90889SApple OSS Distributions    fi
140*43a90889SApple OSS Distributions    if [ ! -e "${SYMROOT}/" ]; then
141*43a90889SApple OSS Distributions	RSYNC_DELETE_SYMROOT=1
142*43a90889SApple OSS Distributions    else
143*43a90889SApple OSS Distributions	RSYNC_DELETE_SYMROOT=0
144*43a90889SApple OSS Distributions    fi
145*43a90889SApple OSS Distributions    if [ ! -e "${DSTROOT}/" ]; then
146*43a90889SApple OSS Distributions	RSYNC_DELETE_DSTROOT=1
147*43a90889SApple OSS Distributions    else
148*43a90889SApple OSS Distributions	RSYNC_DELETE_DSTROOT=0
149*43a90889SApple OSS Distributions    fi
150*43a90889SApple OSS Distributions    TARBUILDDIRS=0
151*43a90889SApple OSS Distributionsfi
152*43a90889SApple OSS Distributions
153*43a90889SApple OSS Distributionsecho "Caching build tools..." 1>&2
154*43a90889SApple OSS Distributionsmkdir -p "${BUILDTOOLSDIR}" || die "Could not create BUILDTOOLSDIR"
155*43a90889SApple OSS Distributions$MAKE print_exports "${ARGS[@]}" XCRUN="${SRC}/tools/xcrun_cache.sh -c \"${BUILDTOOLSDIR}\"" >/dev/null || die "Could not cache build tools"
156*43a90889SApple OSS Distributions
157*43a90889SApple OSS Distributions# Cache the make(1) binary itself
158*43a90889SApple OSS DistributionsMAKE_SDKROOT=`"${SRC}/tools/xcrun_cache.sh" -u "${BUILDTOOLSDIR}" -sdk / -show-sdk-path`
159*43a90889SApple OSS Distributions"${SRC}/tools/xcrun_cache.sh" -c "${BUILDTOOLSDIR}" -sdk "${MAKE_SDKROOT}" -find make >/dev/null || die "Could not cache make"
160*43a90889SApple OSS Distributions
161*43a90889SApple OSS Distributions# Create a canned build script that can restart the build on the remote server.
162*43a90889SApple OSS Distributionsmkdir -p "${BUILDSCRIPTDIR}" || die "Could not create BUILDSCRIPTDIR"
163*43a90889SApple OSS Distributionscat > "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}" <<EOF
164*43a90889SApple OSS Distributions#!/bin/sh
165*43a90889SApple OSS Distributionsmkdir -p /private/tmp
166*43a90889SApple OSS Distributionsmkdir -p /private/var/tmp
167*43a90889SApple OSS Distributionsmkdir -p "\${TMPDIR}"
168*43a90889SApple OSS Distributionscd "${REMOTE_SRCREL}"
169*43a90889SApple OSS Distributionsmkdir -p ./BUILD/obj
170*43a90889SApple OSS Distributionsmkdir -p ./BUILD/sym
171*43a90889SApple OSS Distributionsmkdir -p ./BUILD/dst
172*43a90889SApple OSS DistributionsMAKE=\`\$PWD/tools/xcrun_cache.sh -u "\$PWD/${REMOTE_BUILDTOOLSREL}" -sdk / -find make\`
173*43a90889SApple OSS Distributionsif [ -z "\${MAKE}" ]; then exit 1; fi
174*43a90889SApple OSS Distributions\${MAKE} ${TARGET} ${REMOTEARGS[@]} XCRUN="\$PWD/tools/xcrun_cache.sh -u \"\$PWD/${REMOTE_BUILDTOOLSREL}\""
175*43a90889SApple OSS Distributionsret=\$?
176*43a90889SApple OSS Distributionsif [ \$ret -eq 0 ]; then
177*43a90889SApple OSS Distributionsif [ ${TARBUILDDIRS} -eq 1 ]; then
178*43a90889SApple OSS Distributionstar jcf ./BUILD/obj.tar.bz2 --exclude=\*.o --exclude=\*.cpo --exclude=\*.d --exclude=\*.cpd --exclude=\*.non_lto --exclude=\*.ctf --exclude=conf -C ./BUILD/obj . || exit 1
179*43a90889SApple OSS Distributionstar jcf ./BUILD/sym.tar.bz2 -C ./BUILD/sym . || exit 1
180*43a90889SApple OSS Distributionstar jcf ./BUILD/dst.tar.bz2 -C ./BUILD/dst . || exit 1
181*43a90889SApple OSS Distributionsfi
182*43a90889SApple OSS Distributionsfi
183*43a90889SApple OSS Distributionsexit \$ret
184*43a90889SApple OSS DistributionsEOF
185*43a90889SApple OSS Distributionschmod a+x "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}"
186*43a90889SApple OSS Distributions#echo "Build script is:"
187*43a90889SApple OSS Distributions#cat "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}"
188*43a90889SApple OSS Distributions
189*43a90889SApple OSS Distributionsmkdir -p "${BUILDTOOLSDIR}/empty"
190*43a90889SApple OSS Distributions
191*43a90889SApple OSS Distributionsif [ "$REMOTEBUILD" = "$SPECIALREMOTEBUILD" ]; then
192*43a90889SApple OSS Distributions    :
193*43a90889SApple OSS Distributionselse
194*43a90889SApple OSS Distributions
195*43a90889SApple OSS Distributions    REMOTEBUILD="$REMOTEBUILD"
196*43a90889SApple OSS Distributions    REMOTEBUILDPATH="$REMOTEBUILDPATH"
197*43a90889SApple OSS Distributions
198*43a90889SApple OSS Distributions    if [ -z "$REMOTEBUILDPATH" ]; then
199*43a90889SApple OSS Distributions	WHOAMI=`whoami`
200*43a90889SApple OSS Distributions	case "${REMOTEBUILD}" in
201*43a90889SApple OSS Distributions	    *@*)
202*43a90889SApple OSS Distributions		WHOAMI=`echo "${REMOTEBUILD}" | awk -F@ '{print $1}'`
203*43a90889SApple OSS Distributions		;;
204*43a90889SApple OSS Distributions	esac
205*43a90889SApple OSS Distributions	REMOTEBUILDPATH="/tmp/$WHOAMI"
206*43a90889SApple OSS Distributions    fi
207*43a90889SApple OSS Distributions
208*43a90889SApple OSS Distributions# Construct a unique remote path
209*43a90889SApple OSS Distributions    eval `stat -s "${SRC}"`
210*43a90889SApple OSS Distributions
211*43a90889SApple OSS Distributions    REMOTEBUILDPATH="${REMOTEBUILDPATH}/$st_ino/${SRCNAME}/"
212*43a90889SApple OSS Distributions    echo "Remote path is ${REMOTEBUILD}:${REMOTEBUILDPATH}" 1>&2
213*43a90889SApple OSS Distributions
214*43a90889SApple OSS Distributions    ssh $REMOTEBUILD "mkdir -p \"${REMOTEBUILDPATH}/BUILD/\"{obj,sym,dst}" || die "Could not make remote build directory"
215*43a90889SApple OSS Distributions
216*43a90889SApple OSS Distributions    # Copy source only
217*43a90889SApple OSS Distributions    rsync $RSYNC_ARGS --delete --exclude=\*~ --exclude=.svn --exclude=.git --exclude=/BUILD . $REMOTEBUILD:"${REMOTEBUILDPATH}" || die "Could not rsync source tree"
218*43a90889SApple OSS Distributions
219*43a90889SApple OSS Distributions    # Copy partial OBJROOT (just build tools and build script), and optionally delete everything else
220*43a90889SApple OSS Distributions    rsync $RSYNC_ARGS --delete $RSYNC_DELETE_EXCLUDED --include=/build.sh --include=/BuildTools --include=/BuildTools/\*\* --exclude=\* "${OBJROOT}/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/obj/" || die "Could not rsync build tree"
221*43a90889SApple OSS Distributions
222*43a90889SApple OSS Distributions    # Delete remote SYMROOT if it has been deleted locally
223*43a90889SApple OSS Distributions    if [ "$RSYNC_DELETE_SYMROOT" -eq 1 ]; then
224*43a90889SApple OSS Distributions	rsync $RSYNC_ARGS --delete "${BUILDTOOLSDIR}/empty/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/sym/" || die "Could not rsync delete SYMROOT"
225*43a90889SApple OSS Distributions    fi
226*43a90889SApple OSS Distributions
227*43a90889SApple OSS Distributions    # Delete remote DSTROOT if it has been deleted locally
228*43a90889SApple OSS Distributions    if [ "$RSYNC_DELETE_DSTROOT" -eq 1 ]; then
229*43a90889SApple OSS Distributions	rsync $RSYNC_ARGS --delete "${BUILDTOOLSDIR}/empty/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/dst/" || die "Could not rsync delete DSTROOT"
230*43a90889SApple OSS Distributions    fi
231*43a90889SApple OSS Distributions
232*43a90889SApple OSS Distributions    # Start the build
233*43a90889SApple OSS Distributions    echo ssh $REMOTEBUILD "/bin/bash -c 'cd \"${REMOTEBUILDPATH}\" && ${REMOTE_BUILDSCRIPTREL}/${BUILDSCRIPTNAME}'" 1>&2
234*43a90889SApple OSS Distributions    ssh $REMOTEBUILD "/bin/bash -c 'cd \"${REMOTEBUILDPATH}\" && ${REMOTE_BUILDSCRIPTREL}/${BUILDSCRIPTNAME}'" || die "Could not complete remote build"
235*43a90889SApple OSS Distributions
236*43a90889SApple OSS Distributions    # Copy back build results except for object files (which might be several GB)
237*43a90889SApple OSS Distributions    echo "Copying results back..."
238*43a90889SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g --exclude=\*.o --exclude=\*.cpo --exclude=\*.d --exclude=\*.cpd --exclude=\*.non_lto --exclude=\*.ctf $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/obj/" "${OBJROOT}/" || die "Could not rsync build results"
239*43a90889SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/sym/" "${SYMROOT}/" || die "Could not rsync build results"
240*43a90889SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/dst/" "${DSTROOT}/" || die "Could not rsync build results"
241*43a90889SApple OSS Distributions
242*43a90889SApple OSS Distributionsfi
243*43a90889SApple OSS Distributions
244*43a90889SApple OSS Distributionsexit 0
245